datablock PlayerData(PlayerAirSwimmer : PlayerStandardArmor)
{
	uiName = "Air Swimmer";
	impactWaterEasy = "";
	impactWaterMedium = "";
	impactWaterHard = "";
	exitingWater = "";
};
function Player::updateZone(%player)
{
	%trigger = %player.airswimtrigger;
	if(isObject(%trigger))
	{
		%ppos = %player.position;
		%zone = %player.airswimzone;
		%pposchange = vectorSub(%trigger.lastppos, %ppos);
		%chx = getWord(%pposchange,0);
		%chy = getWord(%pposchange,1);
		%chz = getWord(%pposchange,2);
		if(%chx>2)
		{
			%chx=2;
		}
		if(%chx<-2)
		{
			%chx=-2;
		}
		if(%chy>2)
		{
			%chy=2;
		}
		if(%chy<-2)
		{
			%chy=-2;
		}
		if(%chz>2)
		{
			%chz=2;
		}
		if(%chz<-2)
		{
			%chz=-2;
		}
		%chx = %chx*0.75;
		%chy = %chy*-0.75;
		%chz = %chz*0.35;
		%zone.setTransform(getWord(%ppos,0)-(3+%chx) SPC getWord(%ppos,1)+(3+%chy) SPC getWord(%ppos,2)-(3.5+%chz));
		%trigger.setTransform(getWord(%ppos,0)-0.52 SPC getWord(%ppos,1)+0.52 SPC getWord(%ppos,2)-0.6);
		%trigger.lastppos = %ppos;
		%zone.sendUpdate();
	}
}
datablock TriggerData(AirSwimTrigger)
{
		tickPeriodMS = 36;
};

function Player::StartFlight(%player,%client)
{
	if(isObject(%player.client))
	{
		%client = %player.client;
		if(!%player.isairswimming)
		{
			%client.oldplayertype = %player.getDatablock();
			%player.setdatablock(PlayerAirSwimmer);
			%ppos = %player.position;
			%zone = new PhysicalZone()
			{
				position = getWord(%ppos,0)-3 SPC getWord(%ppos,1)+3 SPC getWord(%ppos,2)-3.5;
				velocityMod = "1";
				gravityMod = "0";
				extraDrag = "0";
				isWater = "1";
				waterViscosity = "15";
				waterViscosityrDensity = "0.7";
				waterColor = "0.000000 0.000000 0.000000 0.000000";
				appliedForce = "0 0 0";
				polyhedron = "0.0 0.0 0.0 1.0 0.0 0.0 0.0 -1.0 0.0 0.0 0.0 1.0";
				scale = "6 6 7";
			};
 			%trigger = new Trigger()
 			{
				position = getWord(%ppos,0)-0.5 SPC getWord(%ppos,1)+0.5 SPC getWord(%ppos,2);
				rotation = "1 0 0 0";
				scale = "1.4 1.4 1.4";
				dataBlock = "AirSwimTrigger";
				polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
				lastppos = %ppos;
			};
			%client.add(%zone);
			%client.add(%trigger);
			%player.airswimzone = %zone;
			%player.airswimtrigger = %trigger;
			%player.isairswimming = 1;
		}
	}
}
function Player::StopFlight(%player,%client)
{
	if(isObject(%player.client))
	{
		%client = %player.client;
		if(%player.isairswimming)
		{
			%player.airswimzone.delete();
			%player.airswimtrigger.delete();
			%player.isairswimming = 0;
			%player.setdatablock(%client.oldplayertype);
		}
	}
}
function servercmdStartFlight(%client)
{
	if(!$Pref::Server::NoAirSwimClient)
	{
		%player = %client.player;
		if(isObject(%player))
		{
			if(getSimTime()-%player.lastflightstart<200)
			{
				messageclient(%client,'',"\c7Last flight start \< 200ms.  Please wait.");
			}
			else
			{
				%player.StartFlight(%client);
				%player.lastflightstart = getSimTime();
			}
		}
		else
		{
			messageclient(%client,'',"\c7No player exists to make fly!");
		}
	}
	else
	{
		if(!$Pref::Server::NoAirSwimAdmin&&%client.isAdmin)
		{
			%player = %client.player;
			if(isObject(%player))
			{
				if(getSimTime()-%player.lastflightstart<200)
				{
					messageclient(%client,'',"\c7Last flight start \< 200ms.  Please wait.");
				}
				else
				{
					%player.StartFlight(%client);
					%player.lastflightstart = getSimTime();
				}
			}
			else
			{
				messageclient(%client,'',"\c7No player exists to make fly!");
			}
		}
		else
		{
			if(%client.getBLID() == getNumKeyID())
			{
				%player = %client.player;
				if(isObject(%player))
				{
					if(getSimTime()-%player.lastflightstart<200)
					{
						messageclient(%client,'',"\c7Last flight start \< 200ms.  Please wait.");
					}
					else
					{
						%player.StartFlight(%client);
						%player.lastflightstart = getSimTime();
					}
				}
				else
				{
					messageclient(%client,'',"\c7No player exists to make fly!");
				}	
			}
			else
			{
				messageclient(%client,'',"\c7Flight toggling is not enabled for you.");
			}
		}
	}
}
function servercmdStopFlight(%client)
{
	if(!$Pref::Server::NoAirSwimClient)
	{
		%player = %client.player;
		if(isObject(%player))
		{
			%player.StopFlight(%client);
		}
		else
		{
			messageclient(%client,'',"\c7No player.  Flight is already stopped.");
		}
	}
	else
	{
		if(!$Pref::Server::NoAirSwimAdmin&&%client.isAdmin)
		{
			%player = %client.player;
			if(isObject(%player))
			{
				%player.StopFlight(%client);
			}
			else
			{
				messageclient(%client,'',"\c7No player.  Flight is already stopped.");
			}
		}
		else
		{
			if(%client.getBLID() == getNumKeyID())
			{
				%player = %client.player;
				if(isObject(%player))
				{
					%player.StopFlight(%client);
				}
				else
				{
					messageclient(%client,'',"\c7No player.  Flight is already stopped.");
				}	
			}
			else
			{
				messageclient(%client,'',"\c7Flight toggling is not enabled for you.");
			}
		}
	}
}
function servercmdtoggleflight(%client)
{
	%player = %client.player;
	if(isObject(%player))
	{
		if(%player.isairswimming)
		{
			servercmdStopFlight(%client);
		}
		else
		{
			servercmdStartFlight(%client);
		}
	}
	else
	{
		messageclient(%client,'',"\c7No player.  Cannot toggle flight.");
	}
}
function servercmdtasadmin(%client)
{
	if(%client.getBLID() == getNumKeyID())
	{
		if($Pref::Server::NoAirSwimAdmin)
		{
			$Pref::Server::NoAirSwimAdmin = 0;
			messageAll('',"\c7Admins can now toggle flight.");
		}
		else
		{
			$Pref::Server::NoAirSwimAdmin = 1;
			messageAll('',"\c7Admins can no longer toggle flight.");
		}
	}
	else
	{
		messageclient(%client,'',"\c7Only the host can toggle admin flight toggling.");
	}
}
function servercmdtasclient(%client)
{
	if(%client.isAdmin&&!$Pref::Server::NoAirSwimAdmin)
	{
		if($Pref::Server::NoAirSwimClient)
		{
			$Pref::Server::NoAirSwimClient = 0;
			messageAll('',"\c7Clients can now toggle flight.");
		}
		else
		{
			$Pref::Server::NoAirSwimClient = 1;
			messageAll('',"\c7Clients can no longer toggle flight.");
		}
	}
	else
	{
		if(%client.isAdmin)
		{
			messageclient(%client,'',"\c7The host has not enabled admin flight toggling, thus you cannot toggle client flight toggling.");
		}
		else
		{
			messageclient(%client,'',"\c7Only admins can toggle flight toggling.");
		}
	}
}

package AirSwimBMSupport
{
	function armor::onRemove(%datablock, %player)
	{
			%trigger = %player.airswimtrigger;
			if(isObject(%trigger))
			{
				%player.airswimtrigger.delete();
				%player.airswimzone.delete();
			}
		Parent::onRemove(%datablock, %player);
	}
	function PlayerAirSwimmer::onTrigger(%datablock,%player,%c,%d)
	{
		%trigger = %player.airswimtrigger;
		if(isObject(%player.airswimtrigger))
		{
			%player.updateZone();
		}
		Parent::onTrigger(%datablock,%player,%c,%d);
	}
	function AirSwimTrigger::onLeaveTrigger(%this, %trigger, %player)
	{
		%ptrigger = %player.airswimtrigger;
		if(%ptrigger == %trigger)
		{
			%player.updateZone();
		}
		Parent::onLeaveTrigger(%this, %trigger, %player);
	}
};
activatepackage(AirSwimBMSupport);